<html>
  <head>
    <script src="https://unpkg.com/maplibre-gl@2.4.0/dist/maplibre-gl.js"></script>
    <link
      href="https://unpkg.com/maplibre-gl@2.4.0/dist/maplibre-gl.css"
      rel="stylesheet"
    />
    <title>VNG_HACKERS</title>
    <style>
      @import url("https://fonts.googleapis.com/css?family=Roboto+Mono&display=swap");
      body {
        margin: 0;
        padding: 0;
        background-color: black;
        font-family: Roboto Mono;
      }
      #map {
        width: 100vw;
        height: 100vh;
      }
      #topLayer {
        width: 100vw;
        height: 100vh;
        background-color: rgb(25, 22, 22);
        mix-blend-mode: overlay;
        position: fixed;
        pointer-events: none;
        top: 0px;
        left: 0px;
      }

      #buttons {
        z-index: 1000;
        position: absolute;
        top: 50px;
        left: 50px;
        color: #eeff00;
        font-family: Roboto Mono;
        background-color: rgba(0, 0, 0, 0.5);
        padding: 20px;
      }

      button {
        background-color: #fdffe5; /* Green */
        border: none;
        /* color: white; */
        padding: 15px 32px;
        text-align: center;
        text-decoration: none;
        display: inline-block;
        font-size: 16px;
        margin: 4px 2px;
        cursor: pointer;
        font-family: Roboto Mono;
      }
      button:focus {
        background-color: #eeff00;
      }
    </style>
  </head>

  <body>
    <div id="map"></div>
    <!-- <div id="topLayer"></div> -->
    <div id="buttons">
      <h3>Bekijk de regel dichtheid van:</h3>
      <button class="focus" onclick="toggleAdminArea('gm')">Gemeenten</button>
      <button onclick="toggleAdminArea('pv')">Provincies</button>
      <button onclick="toggleAdminArea('ws')">waterschap</button>

      <button onclick="toggleAdminArea('alles')">alles</button>

      <h3>Aantal gebieden: <span id="totaal"></span></h3>
      <h3>Geklikt op: <span id="admin"></span></h3>

      <h3>Of filter op</h3>
      <button onclick="toggleAdminArea('gebied')">gebied</button>
      <button onclick="toggleAdminArea('ambtsgebied')">ambtsgebied</button>
    </div>
    <script>
      document.querySelector(".focus").focus({ focusVisible: true });
      let style = {
        id: "myStyle",
        version: 8,
        // sprite:
        //   "https://service.pre.omgevingswet.overheid.nl/publiek/omgevingsdocumenten/api/verbeelden/v3/spritesheet",
        sources: {
          dso: {
            type: "vector",
            tiles: [
              "https://service.pdok.nl/omgevingswet/omgevingsdocumenten-pre/wmts/v1_0/locaties/EPSG:28992/{z}/{x}/{y}.pbf",
            ],
          },
        },
        layers: [
          {
            id: "dsoClick",
            source: "dso",
            "source-layer": "vlaklocaties",
            type: "fill",
            filter: [
              "in",
              `nl.imow-gm`,
              ["to-string", ["get", "identificatie"]],
            ],
            paint: {
              // MapLibre Style Specification paint properties
              "fill-color": "rgba(255,255,255,0.05)",
            },
            layout: {
              // MapLibre Style Specification layout properties
            },
          },
          {
            id: "dsoVisual-line",
            source: "dso",
            "source-layer": "vlaklocaties",
            type: "line",
            filter: ["all", ["==", "hash", "0"]],
            paint: {
              "line-color": "#eeff00",
              "line-width": 1,
            },
            layout: {},
          },
          {
            id: "dsoVisual",
            source: "dso",
            "source-layer": "vlaklocaties",
            type: "fill",
            filter: ["all", ["==", "hash", "0"]],
            paint: {
              "fill-color": "rgba(153,125,4,0.01)",
              "fill-outline-color": "rgba(0,0,0,0.1)",
            },
            layout: {},
          },
          {
            id: "werkingsgebied-grens",
            type: "line",
            niveau: 0,
            source: "dso",
            "source-layer": "vlaklocaties",
            paint: {
              "line-color": "#0000c5",
              "line-opacity": 1,
              "line-width": 2,
              "line-dasharray": [3, 3],
            },
            filter: ["all", ["in", "hash", "0"]],
          },
        ],
      };

      maplibregl.workerCount = 8;
      maplibregl.prewarm();
      var map = new maplibregl.Map({
        container: "map",
        style: style,
        center: [4, 52], // starting position [lng, lat]
        zoom: 9, // starting zoom
        hash: true,
      });
      map.addControl(new maplibregl.NavigationControl());
      map.on("click", "dsoClick", function (e) {
        let filterArray = [];
        let features = e.features;
        map.flyTo({
          center: e.lngLat,
        });

        features.forEach((element) => {
          filterArray.push(element.properties.identificatie);
        });

        let filter = ["all", ["in", "identificatie", ...filterArray]];

        map.setFilter("dsoVisual", filter);
        map.setFilter("dsoVisual-line", filter);

        map.setFilter("werkingsgebied-grens", [
          "all",
          ["in", "identificatie", features[0].properties.identificatie],
        ]);

        document.getElementById("totaal").innerHTML = `${filterArray.length}`;
        document.getElementById(
          "admin"
        ).innerHTML = `${features[0].properties.identificatie}`;
      });

      function toggleAdminArea(admin) {
        switch (admin) {
          case "alles":
            map.setPaintProperty(
              "dsoClick",
              "fill-color",
              "rgba(255,255,255,0.05)"
            );
            map.setFilter("dsoClick", null);
            break;
          case "gebied":
            map.setFilter("dsoClick", [
              "in",
              `.${admin}.`,
              ["to-string", ["get", "identificatie"]],
            ]);

            map.setPaintProperty(
              "dsoClick",
              "fill-color",
              "rgba(255,255,255,0.05)"
            );
            break;
            case  "ambtsgebied":
            map.setFilter("dsoClick", [
              "in",
              `.${admin}.`,
              ["to-string", ["get", "identificatie"]],
            ]);

            map.setPaintProperty(
              "dsoClick",
              "fill-color",
              "rgba(255,255,255,0.05)"
            );
            break;
          default:
            map.setFilter("dsoClick", [
              "in",
              `nl.imow-${admin}`,
              ["to-string", ["get", "identificatie"]],
            ]);
            map.setPaintProperty(
              "dsoClick",
              "fill-color",
              "rgba(255,255,255,0.09)"
            );
            break;
        }
      }
    </script>
  </body>
</html>
